;==========================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;      ----------------------
;(c)1982   By D.P. AKNAI & M.STREETON
;      ----------------------
;Revised version by Carlo Delhez, 1991
;==========================
ORG 5014		;20500

@DFILE=400C
@SEED=4032
@LADDR=09D8
@VARS=4010
@X1Y1=4036
@X2Y2
	00 00
@PFLAG
	00 00
@VAR
	00 00 00 00
;==========================
;PLOT Routine, full screen PLOT/UNPLOT
;statements. Modified from...
;
;Um Plot Rpido (RAPID PLOT)
;"Usando Linguagem De Mquina" 
;by Mario Schaeffer
;
;B=Y, 0 to 43
;C=X, 0 to 63
;Pixel 0-NW	A=87
;Pixel 1-NE	A=8F
;Pixel 2-SW	A=97
;Pixel 3-SE	A=9F
;==========================
;Test for XY out of range errors
;==========================
@TESTXY
	LD BC,(X1Y1)	;BC=XY COORDS
@TESTX
	LD A,3F		;X>63?
	SUB C 
	JR NC TESTY
@ERRORH
	RST 08		;Yes, Error Code:'H'
	10		;X>63
@TESTY
	LD A,2F		;Y>47?
	SUB B 
	RET NC
@ERRORV
	RST 08		;Yes, Error Code:'V'
	1E		;Y>43
;==========================
@PLOT
	CALL TESTXY
	LD A,40
	JR PLOT01
@XPLOT
	CALL TESTXY
	XOR A
@PLOT01			;Is Y an ODD or EVEN row?
	PUSH AF		;SAVE PLOT/UNPLOT value.
	LD A,87		;A=87=NW Pixel
	BIT 0,B		;Y
	JR NZ PLOT02	;ODD line number?
			;No, must be an EVEN line number 
	ADD A,10		;A=97=SW Pixel 
@PLOT02			;Is X ODD or EVEN column?		
	BIT 0,C		;X
	JR Z PLOT03	;EVEN col number?
			;No, must be an ODD row number 
	ADD A,08		;A=8F=NE Pixel or A=9F=SE Pixel
@PLOT03
	LD D,A		;D=Pixel quadrant value
	POP AF
	ADD A,D		;A=D IF UNPLOT or D+64 IF PLOT
	LD (PLOTPX+1),A	;Self modifying code
	SRL B		;Convert Y-coord to Print coord, Y/2
	SRL C		;Convert X-coord to Print coord, X/2
	LD HL,(DFILE)
	INC HL
	LD D,00
	LD E,C		;DE=Column number
	ADD HL,DE	;HL=Column position in DFILE
	LD A,17		;23-Y/2
	SUB B
	LD B,A		;B=Row number
	JR Z PLOT05
	LD DE,21
@PLOT04
	ADD HL,DE
	DJNZ PLOT04
@PLOT05
	LD A,(HL)
	CP 08		;LO Pixel Chr?
	JR C PLOTPX	;Yes, PLOT it.
	CP 80		;Test for NON-PIXEL Chr code
	JR C NOTPXL	;Code<128
	CP 88		;Code>135
	CPL
	JR C PLOTPX
@NOTPXL
	XOR A		;LET A=0, Space Chr. code
@PLOTPX
	SET 00,A		;00=SR SET/RES X,A
	BIT 3,A
	JR Z LOWPX
	CPL
	AND 8F
	JR HIPX
@LOWPX			;Low value PIXEL, codes 1 to 7
	AND 0F
@HIPX			;Hi value PIXEL, codes 128 to 135
	LD (HL),A
	RET 
;==========================
;DRAW/UNDRAW
;Modified from "ZX Stuff" by
;H. Stamm and Ch. Zwerschke
;==========================
@DRAW
	LD A,40
	JR DRW00
@XDRAW
	XOR A 
@DRW00
	LD (PFLAG),A
@DRW0A
	LD HL,(X1Y1)	;Draw START Coords 
	LD DE,(X2Y2)	;Draw END Coords
	LD A,E		;Y Line length 
	SUB L 
	LD C,A 
	LD A,D		;A=Y Line length 
	SUB H 
	LD B,A 
	JR Z DRW01
	RLA 
	SBC A,A
	SET 0,A 
@DRW01
	LD (VAR+1),A 
	LD (VAR+3),A 
	LD A,C 
	AND A 
	JR Z DRW02
	RLA 
	SBC A,A 
	SET 0,A 
@DRW02
	LD (VAR),A 
	LD (VAR+2),A 
	LD A,C 
	BIT 7,A 
	JR Z DRW03
	NEG 
@DRW03
	LD E,A 
	LD A,B 
	BIT 7,A 
	JR Z DRW04
	NEG 
@DRW04
	LD D,A 
	SUB E 
	JR C DRW05
	XOR A 
	LD (VAR+2),A 
	LD A,E 
	LD E,D 
	LD D,A 
	JR DRW06
@DRW05
	XOR A 
	LD (VAR+3),A 
@DRW06
	LD C,E 
	SRL C 
	LD B,E 
	INC B 
@DRW07
	PUSH HL 
	PUSH DE 
	PUSH BC 
	LD (X1Y1),HL 
	CALL TESTXY 
	LD A,(PFLAG)
	CALL PLOT01
	POP BC 
	POP DE 
	POP HL 
	LD A,C 
	ADD A,D 
	LD C,A 
	SUB E 
	JR C DRW08
	LD C,A 
	LD A,(VAR) 
	ADD A,L 
	LD L,A 
	LD A,(VAR+1) 
	ADD A,H 
	LD H,A 
	JR DRW09
@DRW08
	LD A,(VAR+2) 
	ADD A,L 
	LD L,A 
	LD A,(VAR+3) 
	ADD A,H 
	LD H,A 
@DRW09
	DJNZ DRW07
	LD HL,(X2Y2)
	LD (X1Y1),HL
	RET
;==========================
;Convert a 2 digit string to numeric value.
;==========================
@VALXY
	INC HL		;Point to CHR DATA 
	LD A,(HL)	;Check for EOL?
	CP 76
	RET Z
	CP B2
	RET Z
	CP ","		;Optional seperator
	JR Z VALXY	;SKIP seperator
	AND A		;LET A=VAL "NN", Clear CF
	SBC A,1C		;CHR Code to numeric value
	LD B,A		;B=10's digit	
	JR Z VAL02	;IF B=0 THEN JUMP VAL02
	XOR A		;Clear A & CF
@VAL01
	ADD A,0A		;LET A=10*B
	DJNZ VAL01
@VAL02
	LD B,A		;B=10's value
	INC HL		;Next CHR
	LD A,(HL)
	SBC A,1C		;CHR Code to numeric value
	ADD A,B		;A=VAL "NN"
	RET 
;==========================
;Data DRAW
;==========================
@DDRAW
	LD A,40
	LD (PFLAG),A
	JR DDR00
@XDDRW
	XOR A
	LD (PFLAG),A
@DDR00
	LD HL,(SEED)	;Get DATA line number
	CALL LADDR	;Find it's address
	LD BC,0004	;Skip line header bytes
	ADD HL,BC	;HL=Start address-1 of DATA
@DDR01
	CALL VALXY	;Get X2 value
	CP 76		;EOL/DATA reached?
	RET Z		;Yes, return to BASIC
	CP B2		;Set MOVETO coords
	JR NZ DDR02
	CALL VALXY	;Get X1 value
	LD (X1Y1),A	;SET X1 value
	CALL VALXY	;Get Y1 value
	LD (X1Y1+1),A	;SET Y1 value
	JR DDR01
@DDR02
	LD (X2Y2),A	;SET X2 value
	CALL VALXY	;Get Y2 value
	LD (X2Y2+1),A	;SET Y2 value
	PUSH HL		;Save DATA pointer
	LD A,(PFLAG)
	CALL DRW0A
	POP HL		;RESTORE DATA pointer
	JR DDR01
;==========================
;POINT function
;Returns 0 if pixel not set, >0 if set
;Chr Code at PRINT Y,X position stored at
;B=Y Plot coord, 0 to 43
;C=X Plot coord, 0 to 63
;==========================
;PIXEL character tables
@NWQ 				;CHR's with NW Pixel set
	01 03 05 07 80 82 84 86
@NEQ				;CHR's with NE Pixel set
	02 03 06 07 80 81 84 85
@SWQ				;CHR's with SW Pixel set
	04 05 06 07 80 81 82 83
@SEQ				;CHR's with SE Pixel set
	80 81 82 83 84 85 86 87

@POINT
	LD BC,(X2Y2)
	LD HL,NWQ	;HL=NW Pixel DATA
	BIT 0,B		;BIT 0 Y
	JR NZ PNT01	;Is Y ODD or EVEN?
			;No, Y must be EVEN 
	LD HL,SWQ	;HL=SW Pixel DATA
@PNT01		
	BIT 0,C		;BIT 0 X
	JR Z PNT02	;Is X ODD or EVEN?
			;No, X must be ODD 
	LD DE,0008
	ADD HL,DE	;HL=NE Pixel DATA or
			;HL=SE Pixel DATA
@PNT02			;GET the CHR at PLOT X,Y Coords
	PUSH HL		;SAVE table pointer
	SRL B		;Convert Y PLOT coord to X Print coord, Y/2
	SRL C		;Convert X PLOT coord to Y Print coord, X/2
	LD HL,(DFILE)	;FIND character location in DFILE
	INC HL		
	LD D,00		
	LD E,C		;DE=X
	ADD HL,DE	;HL=DFILE+X
	LD A,17		;A=ROW number, 23-Y/2
	SUB B		;A=PRINT Y coord 
	LD B,A		;B=Row number
	JR Z PNT04
	LD DE,21		;33 Bytes/row
@PNT03
	ADD HL,DE	;Add B rows to HL
	DJNZ PNT03
@PNT04			;CHR location=DFILE+33*Y+X
	LD A,(HL)	;A=Character to test
	LD (PFLAG+1),A	;Save the Chr Code, may be useful later
	POP HL		;RESTORE TABLE pointer
	LD BC,0009
	CPIR		;Search for match
	RET		;RETURN with BC=0 if no match found
;==========================
;Scrolls by Stephane Crainic from
;Sinclair Programs, Jan./Feb. 1983, page 22
;==========================
@UP
	LD HL,(DFILE)
	PUSH HL 
	LD DE,0021 
	ADD HL,DE 
	POP DE 
	LD BC,02F7 
	LDIR 
	LD DE,0021 
	SBC HL,DE 
	JR LBL001
;==========================
@DOWN
	LD HL,(VARS)
	DEC HL 
	PUSH HL 
	LD DE,0021 
	SBC HL,DE 
	POP DE 
	LD BC,02F7 
	LDDR 
	LD HL,(DFILE)
@LBL001
	LD B,20 
@LBL002
	INC HL 
	LD (HL),00 
	DJNZ LBL002
	RET
;==========================
@LEFT
	LD HL,(DFILE)
	LD DE,0318 
	ADD HL,DE 
	LD B,18 
@LBL003
	DEC HL 
	LD C,(HL) 
	LD (HL),00 
@LBL004
	DEC HL 
	LD A,(HL) 
	CP 76 
	JR Z LBL005
	JR LBL006
@LBL005
	DJNZ LBL003
	LD C,00 
	RET
@LBL006
	LD (HL),C 
	LD C,A 
	JR LBL004
;==========================
@RIGHT
	LD HL,(DFILE)
	LD B,18 
@LBL007
	INC HL 
	LD C,(HL) 
	LD (HL),00 
@LBL008
	INC HL 
	LD A,(HL) 
	CP 76 
	JR Z LBL009
	JR LBL00A
@LBL009
	DJNZ LBL007
	LD C,00 
	RET
@LBL00A
	LD (HL),C 
	LD C,A 
	JR LBL008
;==========================
@SE
	CALL RIGHT
	CALL DOWN
	RET
;==========================
@SW
	CALL LEFT
	CALL DOWN
	RET
;==========================
@NW
	CALL LEFT
	CALL UP
	RET
;==========================
@NE
	CALL RIGHT
	CALL UP
	RET
;==========================
;Invert the display
;==========================
@INVERT
	LD BC,318
	LD HL,(DFILE)
	INC HL
@INV01
	LD A,(HL)
	CP 76
	JR Z INV02
	ADD A,80
	LD (HL),A
@INV02
	INC HL
	DEC BC
	LD A,B
	OR C
	JR NZ INV01
	RET